diff --git a/bin/varnishlog/varnishlog.c b/bin/varnishlog/varnishlog.c
index 09f8983d57..b6a76d7df5 100644
--- a/bin/varnishlog/varnishlog.c
+++ b/bin/varnishlog/varnishlog.c
@@ -142,10 +142,15 @@ main(int argc, char * const *argv)
 		VUT_Error(vut, 1, "Missing -w option");
 
 	/* Setup output */
-	if (LOG.A_opt || !LOG.w_arg)
+	if (LOG.A_opt || !LOG.w_arg) {
 		vut->dispatch_f = VSL_PrintTransactions;
-	else
+	} else {
 		vut->dispatch_f = VSL_WriteTransactions;
+		// inefficient but not crossing API layers
+		AN(VUT_Arg(vut, 'i', "Link"));
+		AN(VUT_Arg(vut, 'i', "Begin"));
+		AN(VUT_Arg(vut, 'i', "End"));
+	}
 	if (LOG.w_arg) {
 		openout(LOG.a_opt);
 		AN(LOG.fo);
